This service will be undergoing maintenance at 00:00 UTC, 2016-08-01. It is expected to last about 1 hours
Bug 652648 - Review Request: erlang-skerl - Skein hash function for Erlang, via NIFs
Review Request: erlang-skerl - Skein hash function for Erlang, via NIFs
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Narasimhan
Fedora Extras Quality Assurance
:
Depends On: 639263
Blocks: 848423 652665
  Show dependency treegraph
 
Reported: 2010-11-12 07:57 EST by Peter Lemenkov
Modified: 2015-03-31 22:02 EDT (History)
4 users (show)

See Also:
Fixed In Version: erlang-skerl-1.1.0-10.el7
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-08-02 08:46:41 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
lakshminaras2002: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Peter Lemenkov 2010-11-12 07:57:54 EST
Spec URL: http://peter.fedorapeople.org/erlang-skerl.spec
SRPM URL: http://peter.fedorapeople.org/erlang-skerl-0-0.1.20101112git1f6f580.fc12.src.rpm
Description: Skein hash function for Erlang, via NIFs

This is one of the requirements for Riak
Comment 1 Peter Lemenkov 2010-11-24 10:30:29 EST
Koji scratchbuild for Rawhide:

http://koji.fedoraproject.org/koji/taskinfo?taskID=2621290

rpmlint:

sulaco ~/rpmbuild/SPECS: rpmlint ../RPMS/ppc/erlang-skerl-*
erlang-skerl.ppc: E: explicit-lib-dependency erlang-stdlib
erlang-skerl.ppc: W: no-documentation
2 packages and 0 specfiles checked; 1 errors, 1 warnings.
sulaco ~/rpmbuild/SPECS:
Comment 2 Peter Lemenkov 2011-01-10 10:30:14 EST
Ver. 1.0.0 (the same as previous git snapshot - just tagged as 1.0.0):

http://peter.fedorapeople.org/erlang-skerl.spec
http://peter.fedorapeople.org/erlang-skerl-1.0.0-1.fc12.src.rpm

Koji scratchbuild for Rawhide:

http://koji.fedoraproject.org/koji/taskinfo?taskID=2712377

rpmlint:

sulaco ~: rpmlint Desktop/erlang-skerl-*
erlang-skerl.src: W: invalid-url Source0: basho-skerl-skerl-1.0.0-0-g2c1ee57.tar.gz
erlang-skerl.x86_64: E: explicit-lib-dependency erlang-stdlib
erlang-skerl.x86_64: W: no-documentation
3 packages and 0 specfiles checked; 1 errors, 2 warnings.
sulaco ~: 

The error message above, regarding explicit-lib-dependency, is just a false positive.
Comment 3 Peter Lemenkov 2011-01-16 05:27:11 EST
Adding FE-LEGAL until the status of the following files will be resolved:

* src/hex.erl
* src/skerl.erl

It was already confirmed by upstream developer, that the c_src/erl_nif_compat.h  file is licensed under ASL 2.0.
Comment 4 Peter Lemenkov 2011-01-16 05:30:15 EST
The file c_src/skerl_nifs.c doesn't have any licensing information too.
Comment 5 Narasimhan 2011-03-13 07:54:07 EDT
Hello,
Is there any update from upstream?
Comment 6 Peter Lemenkov 2011-03-13 08:08:58 EDT
(In reply to comment #5)
> Hello,
> Is there any update from upstream?

Not yet. It seems that adding licensing headers is not among the upstream's top priority tasks. I'll ping them again next week.
Comment 7 Tom "spot" Callaway 2011-06-30 13:12:23 EDT
If we can confirm license with the copyright holder via email, that will be sufficient to resolve this issue.
Comment 8 Peter Lemenkov 2011-07-25 02:41:35 EDT
(In reply to comment #7)
> If we can confirm license with the copyright holder via email, that will be
> sufficient to resolve this issue.

I'd rather rewrite them (it'll take me a little more time, but I already spent a lot of time cooking this) - I don't want to look like clueless idiot who keeps asking absolutely irrelevant questions.

Guys, honestly I'm really shocked by the fact that the only issue with this huge and technically complex Erlang project (Riak) was the legal origin of these quite simple files. They are so simple that nobody was interested to add legal information to them so far.
Comment 9 Peter Lemenkov 2012-06-16 16:19:39 EDT
Heads up. I finally found a spare time and rewrote problematic files. the same API but with clear licensing erms - MIT (or whatever else - I'm open for suggestions). Also I added unit-tests (see %check section) to ensure that everything still works fine.

* http://peter.fedorapeople.org/erlang-skerl.spec
* http://peter.fedorapeople.org/erlang-skerl-1.1.0-2.fc18.src.rpm

Koji scratchbuild for Rawhide:

* http://koji.fedoraproject.org/koji/taskinfo?taskID=4171161

Tom, could you please take a look at this package - is it safe to remove FE-LEGAL now?
Comment 10 Peter Lemenkov 2012-06-16 16:22:27 EDT
(In reply to comment #9)

> for suggestions). Also I added unit-tests (see %check section) to ensure

s,added,enabled,
Comment 11 Tom "spot" Callaway 2012-07-26 10:15:02 EDT
Lifting FE-Legal, thanks for doing this hard work. Try to push these changes upstream!
Comment 12 Narasimhan 2012-07-28 05:14:07 EDT
Will
Comment 13 Narasimhan 2012-07-28 05:14:37 EDT
Sorry, saved it before completing the sentence. Will complete the review.
Comment 14 Peter Lemenkov 2012-07-31 10:07:28 EDT
Lakshmi, Ping! :)
Comment 15 Narasimhan 2012-08-01 23:55:32 EDT
I will complete the review by today.
Comment 16 Narasimhan 2012-08-02 07:46:02 EDT
[+]MUST: rpmlint must be run on every package. The output should be posted in the review.
rpmlint -i erlang-skerl-1.1.0-2.fc16.src.rpm erlang-skerl-1.1.0-2.fc16.x86_64.rpm erlang-skerl-debuginfo-1.1.0-2.fc16.x86_64.rpm ../erlang-skerl.spec 
erlang-skerl.src: W: invalid-url Source0: basho-skerl-1.1.0-0-g908d05a.tar.gz
The value should be a valid, public HTTP, HTTPS, or FTP URL.

erlang-skerl.x86_64: E: explicit-lib-dependency erlang-stdlib
You must let rpm find the library dependencies by itself. Do not put unneeded
explicit Requires: tags.

erlang-skerl.x86_64: W: no-documentation
The package contains no documentation (README, doc, etc). You have to include
documentation files.

../erlang-skerl.spec: W: invalid-url Source0: basho-skerl-1.1.0-0-g908d05a.tar.gz
The value should be a valid, public HTTP, HTTPS, or FTP URL.

3 packages and 1 specfiles checked; 1 errors, 3 warnings.

[+]MUST: The package must be named according to the Package Naming Guidelines.
[+]MUST: The spec file name must match the base package %{name}, in the format %{name}.spec
[+]MUST: The package must meet the Packaging Guidelines.
        Naming-Yes
        Version-release - Matches
        License - OK
        No prebuilt external bits - OK, rebar is present but not packaged/used.
        Spec legibity - OK
        Package template - OK
        Arch support - OK, no exclusivearch specified.
        Libexecdir - OK
        rpmlint - yes
        changelogs - OK
        Source url tag  - OK, validated.
        Build Requires list - OK
        Summary and description - OK
[+]MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines.
[+]MUST: The License field in the package spec file must match the actual license.
[NA]MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.
LICENSE file is not present.
[+]MUST: The spec file must be written in American English.
[+]MUST: The spec file for the package MUST be legible.
[+]MUST: The sources used to build the package must match the upstream source,as provided in the spec URL. Reviewers should use md5sum for this task.
md5sum basho-skerl-908d05a.tar.gz erlang-skerl-1.1.0-2.fc18.src/basho-skerl-1.1.0-0-g908d05a.tar.gz 
795d715ca6de399df4b1054403483b0a  basho-skerl-908d05a.tar.gz (downloaded the url given in the spec file as a comment)
795d715ca6de399df4b1054403483b0a  erlang-skerl-1.1.0-2.fc18.src/basho-skerl-1.1.0-0-g908d05a.tar.gz
[+]MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture.
Built on x86_64
[NA]MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch.
No excludearch/exclusivearch specified in spec file.
[+]MUST: All build dependencies must be listed in BuildRequires.
[+]MUST: Packages must NOT bundle copies of system libraries.
Checked with rpmquery --list
[+]MUST: A package must own all directories that it creates.
Checked with rpmquery --whatprovides.
[+]MUST: A Fedora package must not list a file more than once in the spec file's %files listings.
[+]MUST: Permissions on files must be set properly.
Checked with ls -lR
[+]MUST: Each package must consistently use macros.
[+]MUST: The package must contain code, or permissible content.
[NA]MUST: devel packages must require the base package using a fully versioned dependency: Requires: {name} = %{version}-%{release}
[NA]MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section
[+]MUST: Packages must not own files or directories already owned by other packages.
[+]MUST: All filenames in rpm packages must be valid UTF-8.

Should items
[-]SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it.
[+]SHOULD: The reviewer should test that the package functions as described.
Installed the packages. Loaded skerl into erl shell. Ran skerl:hash() function in the shell. Output is fine, checked with the output in skerl_tests.erl.


APPROVED.
Comment 17 Peter Lemenkov 2012-08-02 07:51:04 EDT
Thanks!

New Package SCM Request
=======================
Package Name: erlang-skerl
Short Description: Skein hash function for Erlang, via NIFs
Owners: peter
Branches: f17 el6
InitialCC:
Comment 18 Jon Ciesla 2012-08-02 08:25:23 EDT
Git done (by process-git-requests).
Comment 19 Fedora Update System 2012-08-02 08:45:13 EDT
erlang-skerl-1.1.0-2.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/erlang-skerl-1.1.0-2.el6
Comment 20 Fedora Update System 2012-08-02 08:45:25 EDT
erlang-skerl-1.1.0-2.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/erlang-skerl-1.1.0-2.fc17
Comment 21 Fedora Update System 2012-08-12 22:25:02 EDT
erlang-skerl-1.1.0-2.fc17 has been pushed to the Fedora 17 stable repository.
Comment 22 Fedora Update System 2012-08-21 14:40:37 EDT
erlang-skerl-1.1.0-2.el6 has been pushed to the Fedora EPEL 6 stable repository.
Comment 23 Peter Lemenkov 2015-03-13 06:55:48 EDT
Package Change Request
======================
Package Name: erlang-skerl
New Branches: epel7
Owners: peter
InitialCC: erlang-sig
Comment 24 Jon Ciesla 2015-03-13 07:56:09 EDT
Git done (by process-git-requests).
Comment 25 Fedora Update System 2015-03-13 08:22:30 EDT
erlang-skerl-1.1.0-10.el7 has been submitted as an update for Fedora EPEL 7.
https://admin.fedoraproject.org/updates/erlang-skerl-1.1.0-10.el7
Comment 26 Fedora Update System 2015-03-31 22:02:00 EDT
erlang-skerl-1.1.0-10.el7 has been pushed to the Fedora EPEL 7 stable repository.

Note You need to log in before you can comment on or make changes to this bug.